'use strict';

angular.module('adf.widget.electre.lavoisier')
        .service('domService', 
            [
                function () {
                    /**
                     * The dom element to use.
                     * @type domElement_|Element
                     */
                    var domElement;

                    return {
                        /**
                         * Give the 'domElement' the value of 'domElement_'.
                         * @param {Element} domElement_
                         * @returns {dom_L6.domAnonym$1}
                         */
                        setDom : function (domElement_) {
                            domElement = domElement_;
                            return this;
                        },
                        /**
                         * Give the 'domElement' object.
                         * @returns {domElement_|Element}
                         */
                        getDom : function () {
                            return domElement;
                        },
                        /**
                         * Create a HTML DOM Node with the specified 'tagName'.
                         * @param {String} tagName
                         * @returns {dom_L6.domAnonym$1}
                         */
                        createElement : function (tagName) {
                            domElement = document.createElement(tagName);
                            return this;
                        },
                        /**
                         * Donne à l'attribut 'attributeName' la valeur 'attributeValue'.
                         * @param {String} attributeName
                         * @param {String} attributeValue
                         * @returns {dom_L6.domAnonym$1}
                         */
                        setAttribute : function (attributeName, attributeValue) {
                            domElement.setAttribute(attributeName, attributeValue);
                            return this;
                        },
                        /**
                         * Donne la valeur de l'attribut demandé.
                         * @param {String} attributeName
                         * @returns {String}
                         */
                        getAttribute : function (attributeName) {
                            return domElement.getAttribute(attributeName);
                        },
                        /**
                         * Ajoute un Node enfant avant la fin de celui-ci.
                         * @param {Element|Array<Element>} childNode
                         * @returns {dom_L6.domAnonym$1}
                         */
                        appendChild : function (childNode) {
                            domElement.appendChild(childNode);
                            return this;
                        }
                    };
                }
            ]
        );